/*
Programa kum lekciite po OOP na doc. Buchvarov
Napisana ot men, Ivan Dimitrov Georgiev (veche zavurshil) student po informatika, e-mail ivandg@yahoo.com
*/
#include <iostream.h>
#include <assert.h>
class Array
 { friend ostream &operator<< (ostream &output, const Array &);
   friend istream &operator>> (istream &input, Array &);
   public:
     Array (int = 10);
     Array (const Array &);
     ~Array ();
     int getSize () const;
     const Array &operator= (const Array &);
     int operator== (const Array &) const;
     int operator!= (const Array &) const;
     int &operator[] (int);
     static int getArrayCount ();
   private:
     int *ptr;
     int size;
     static int arrayCount;
 } ;
int Array::arrayCount = 0;
Array::Array (int arraySize)
 { arrayCount++;
   size = arraySize;
   ptr = new int[size];
   assert (ptr != NULL);
   for (int i = 0; i < size; i++) ptr[i] = 0;
 }
Array::Array (const Array &init)
 { arrayCount++;
  size = init.size;
  ptr = new int[size];
  assert (ptr!=NULL);
  for (int i = 0; i < size; i++) ptr[i] = init.ptr[i];
 }
Array::~Array ()
 { arrayCount--;
   delete []ptr;
 }
int Array::getSize () const
 { return size; }
const Array &Array::operator= (const Array &right)
 { if (&right != this)
    { delete []ptr;
      size = right.size;
      ptr = new int[size];
      assert (ptr != NULL);
      for (int i = 0; i < size; i++)
       { ptr[i] = right.ptr[i]; }
    }
   return *this;
 }
int Array::operator== (const Array &right) const
 { if (size != right.size) return 0;
   for (int i = 0; i < size; i++)
    if (ptr[i] != right.ptr[i]) return 0;
   return 1;
 }
int Array::operator!= (const Array &right) const
 { return !(*this==right); }
int Array::getArrayCount ()
 { return arrayCount; }
int &Array::operator[] (int ind)
 { assert (ind>=0 && ind < size); return ptr[ind]; }
istream &operator>> (istream &input, Array &a)
 { for (int i = 0; i < a.size; i++)
    input >> a.ptr[i];
   return input;
 }
ostream &operator<< (ostream &output, const Array &a)
 { int i;
   for (i = 0; i < a.size; i++)
    { output << a.ptr[i] << ' ';
      if ( (i+1) % 10 == 0) output << endl;
    }
   if (i % 10 != 0) output << endl;
   return output;
 }
void main ()
 { cout << Array::getArrayCount () << endl;
   Array integers1 (7), integers2;
   cout << integers1.getSize () << endl;
   cout << integers1 << endl;
   cin >> integers1 >> integers2;
   cout << integers1 << integers2;
   if ( integers1 != integers2)
    cout << "   !\n" << endl;
   Array integers3 (integers1);
   integers1 = integers2;
   integers1[5] = 1000;
   integers1[15] = 1000;
 }

