/*
Programa kum lekciite po OOP na doc. Buchvarov
Napisana ot men, Ivan Dimitrov Georgiev (veche zavurshil) student po informatika, e-mail ivandg@yahoo.com
*/
#include <iostream.h>
#include <iomanip.h>
#include <assert.h>
#include <string.h>
class String
 { friend ostream &operator<< (ostream &, const String &);
   friend istream &operator>> (istream &, String &);
   public:
    String (const char * = "");
    String (const String &);
    ~String ();
    const String &operator= (const String &);
    const String &operator+= (const String &);
   int operator!() const;
   int operator== (const String &) const;
   int operator!= (const String &) const;
   int operator< (const String &) const;
   int operator> (const String &) const;
   int operator<= (const String &) const;
   int operator>= (const String &) const;
   char &operator[] (int);
   String operator () (int, int); //  
   int getLength () const;
 private:
   char *sPtr;
   int length;
} ;
String::String (const char *s)
 { length = strlen (s);
   sPtr = new char[length+1];
   assert (sPtr!=NULL);
   strcpy (sPtr, s);
 }
String::String (const String &copy)
 { length = copy.length;
   sPtr = new char [length+1];
   assert (sPtr != NULL);
   strcpy (sPtr, copy.sPtr);
 }
String::~String ()
 { delete []sPtr; }
const String &String::operator= (const String &right)
 { if (&right != this)
    { delete []sPtr;
      length = right.length;
      sPtr = new char[length+1];
      assert (sPtr != NULL);
    }
   return *this;
 }
const String &String::operator+= (const String &right)
 { char *tempPtr = sPtr;
   length += right.length;
   sPtr = new char [length+1];
   assert (sPtr != NULL);
   strcpy (sPtr, tempPtr);
   strcat (sPtr, right.sPtr);
   delete []tempPtr;
   return *this;
 }
int String::operator! () const
 { return length == 0; }
int String::operator== (const String &right) const
 { return strcmp(sPtr, right.sPtr) == 0; }
int String::operator!= (const String &right) const
 { return strcmp(sPtr, right.sPtr) != 0; }
int String::operator< (const String &right) const
 { return strcmp(sPtr, right.sPtr) < 0; }
int String::operator> (const String &right) const
 { return strcmp(sPtr, right.sPtr) > 0; }
int String::operator<= (const String &right) const
 { return strcmp(sPtr, right.sPtr) <= 0; }
int String::operator>= (const String &right) const
 { return strcmp(sPtr, right.sPtr) >= 0; }
char &String::operator[] (int subs)
 { assert (subs >= 0 && subs < length);
   return sPtr[subs];
 }
String String::operator() (int index, int subl)
 { assert (index >= 0 && index < length && subl >= 0);
   String sub;
   if (subl == 0 || (index+subl > length))
    sub.length = length - index;
   else sub.length = subl;
   // ,      0     
   delete []sub.sPtr;
   sub.sPtr = new char[sub.length+1];
   assert (sub.sPtr != NULL);
   strncpy (sub.sPtr, sPtr + index, sub.length);
   sub.sPtr[sub.length] = '\0';
   return sub;//   sub
  }
int String::getLength () const
  { return length; }
ostream &operator<< (ostream &output, const String &s)
{  output << s.sPtr; 
   return output;
}
istream &operator>> (istream &input, String &s)
{ char temp[100];
  input >> setw (100) >> temp;
  s = temp;
  return input;
}

void main ()
{ String s1 ("happy"), s2 (" birthday"), s3;
  cout << s1 << s2 << endl << s3 << endl;
  cout << (s1==s2) << endl << (s2 < s1) << endl;
  if (!s3) cout << "s3   !" << endl;
  s3 = s1;
  s1 += s2;
  s1 += " to you!";
  cout << s1 (0, 14) << endl;
  cout << s1 (15, 0) << endl;
  String *s4ptr = new String (s1);
  *s4ptr = *s4ptr;
  delete s4ptr;
  s1[0] = 'H'; s1[6] = 'B'; s1[25] = 'Y';
}

