/*
Programa kum lekciite po OOP na doc. Buchvarov
Napisana ot men, Ivan Dimitrov Georgiev (veche zavurshil) student po informatika, e-mail ivandg@yahoo.com
*/
#include <string.h>
#include <iostream.h>
#include <iomanip.h>
#include <assert.h>
class Employee {
  public:
    Employee (const char *, const char *);
    void print () const;
    ~Employee ();
  private:
    char *firstName, *lastName;
} ;
Employee::Employee (const char *first, const char *last)
 { firstName = new char [ strlen (first) + 1];
   assert (firstName != NULL);
   strcpy (firstName, first);
   lastName = new char [ strlen (last) + 1];
   assert (lastName != NULL);
   strcpy (lastName, last);
 }
void Employee::print () const
 { cout << firstName << ' ' << lastName; }
Employee::~Employee ()
 { delete []firstName; delete []lastName; }

class HourlyWorker : public Employee
 { public:
     HourlyWorker (const char *, const char *, float, float);
     float getPay () const;
     void print () const;
  private:
     float wage, hours;
 } ;
HourlyWorker::HourlyWorker (const char *first, const char *last, 
float initHours, float initWage) : Employee (first, last)
 { hours = initHours; wage = initWage; }
float HourlyWorker::getPay () const
 { return wage*hours; }
void HourlyWorker::print () const
 { Employee::print ();
   cout << " - $" << setiosflags (ios::fixed | ios::showpoint)
   << setprecision (2) << getPay () << endl;
 }
void main ()
 { HourlyWorker h ( "", "", 40, 7.50);
   h.print ();
 }

