/*
Programa kum lekciite po OOP na doc. Buchvarov
Napisana ot men, Ivan Dimitrov Georgiev (veche zavurshil) student po informatika, e-mail ivandg@yahoo.com
*/
#include <iostream.h>
#include <iomanip.h>
class Shape {
 public:
   virtual float area () const { return 0; }
   virtual float volume () const { return 0; }
   virtual void printShapeName () const = 0;
   virtual void print () const = 0;
} ;
class Point : public Shape {
 friend ostream &operator << (ostream &, const Point &);
 public:
   Point (float = 0, float = 0);
   void setPoint (float, float);
   float getX () const { return x; }
   float getY () const { return y; }
   virtual void printShapeName () const { cout << ": "; }
   virtual void print () const;
 private:
   float x, y;
} ;
Point::Point (float a, float b)
 { setPoint (a, b); }
void Point::setPoint (float a, float b)
 { x = a; y = b; }
void Point::print () const
 { cout << '[' << x << ", " << y << ']'; }
ostream &operator<< (ostream &output, const Point &p)
 { output << '[' << p.x << ", " << p.y << ']'; return output; }
class Circle : public Point {
 friend ostream &operator<< (ostream &, const Circle &);
 public:
   Circle (float = 0, float = 0, float = 0);
   void setRadius (float);
   float getRadius () const;
   virtual float area () const;
   virtual void printShapeName () const
    { cout << ": "; }
   virtual void print () const;
 private:
   float radius;
} ;
Circle::Circle (float r, float a, float b) : Point (a, b)
{ setRadius (r); }
void Circle::setRadius (float r)
 { radius  = (r > 0) ? r : 0; }
float Circle::getRadius () const
 { return radius; }
float Circle::area () const
 { return 3.14159*radius*radius; }
void Circle::print () const
 { cout << '[' << getX() << ", " << getY() << "];  = "
           << radius; }
ostream &operator<< (ostream &output, const Circle &c)
 {  output << '[' << c.getX() << ", " << c.getY() << "];  = "
           << c.radius; return output; }
class Cylinder : public Circle {
 friend ostream& operator<< (ostream &output, const Cylinder &);
 public:
  Cylinder (float = 0, float = 0, float = 0, float = 0);
  void setHeight (float h) { height = ( h > 0) ? h : 0; }
  float getHeight () const { return height; }
  virtual float area () const
   { return 2*3.14159*getRadius()*height + 2*Circle::area(); }
  virtual float volume () const
   { return height*Circle::area(); }
  virtual void printShapeName () const
   { cout << ": "; }
  virtual void print () const;
 private:
  float height;
} ;
Cylinder::Cylinder (float h, float r, float a, float b) : Circle (r, a, b)
 { setHeight (h); }
void Cylinder::print () const
 { Circle::print ();
   cout << ";  = " << height;
 }
ostream &operator<<(ostream &output, const Cylinder &c)
 { output << '[' << c.getX() << ", " << c.getY() << "];  = "
          << c.getRadius() << ";  = " << c.height;
   return output;
 }
void main ()
 { cout << setprecision (2) << setiosflags (ios::fixed | ios::showpoint);
   Point point (7, 11);
   Circle circle (3.5, 22, 8);
   Cylinder cylinder (10, 3.3, 10, 10);
   point.printShapeName ();
   cout << point << endl;
   circle.printShapeName ();
   cout << circle << endl;
   cylinder.printShapeName ();
   cout << cylinder << endl;
   Shape *array[3];
   array [0] = &point; array[1] = &circle; array[2] = &cylinder;
   for (int i = 0; i < 3; i++) {
    array[i] -> printShapeName ();
    array[i] -> print ();
    cout << "\n = " << array[i] -> area ()
         << "\n = " << array[i] -> volume () << endl;
    }
}

