/* Zaglaven fail kum programa ot lekciite po SDP
na doc. Buchvarov napisana ot men, Ivan Dimitrov Georgiev
(veche zavurshil) student po informatika, e-mailut mi e
ivandg@yahoo.com
*/
#ifndef LIST_H
#define LIST_H
#include <iostream>
#include <cassert>
#include "listnode.h"
using std::cout;
using std::endl;
template <class NodeType>
class List {
  public:
     List ();
     ~List ();
     void insertAtBeg (const NodeType &);
     void insertAtEnd (const NodeType &);
     bool removeFromBeg (NodeType &);
     bool removeFromEnd (NodeType &);
     bool isEmpty () const;
     void print () const;
  private:
     ListNode <NodeType> *first;
     ListNode <NodeType> *last;
     ListNode <NodeType>* getNewNode (const NodeType &);
} ;
template <class NodeType>
List <NodeType>::List () : first (NULL), last (NULL)
{}
template <class NodeType>
List <NodeType>::~List ()
 { if (!isEmpty()) 
     { cout << "  : ";
       ListNode <NodeType> *current = first, *temp;
       while (current != NULL)
        { temp = current;
          cout << temp -> data << '\n';
          current = current -> next;
          delete temp;
        }
     }
    cout << "   !" << endl;
 }
template <class NodeType>
bool List<NodeType>::isEmpty () const
 { return first==NULL; }
template <class NodeType>
ListNode <NodeType> *List <NodeType>::getNewNode 
       (const NodeType &value)
 { ListNode <NodeType> *ptr = new ListNode <NodeType> (value);
   assert (ptr != NULL);
   return ptr;
 }
template <class NodeType>
void List <NodeType>::insertAtBeg (const NodeType &value)
 { ListNode <NodeType> *ptr = getNewNode (value);
   if ( isEmpty () )
    first = last = ptr;
   else { ptr -> next = first;
            first = ptr;
          }
 }
template <class NodeType>
void List <NodeType>::insertAtEnd (const NodeType &value)
 { ListNode <NodeType> *ptr = getNewNode (value);
   if ( isEmpty () )
    first = last = ptr;
   else { last -> next = ptr;
            last = ptr;
          }
 }
template <class NodeType>
bool List<NodeType>::removeFromBeg (NodeType &value)
 { if ( isEmpty () ) return false;
   ListNode <NodeType> *temp = first;
   if (first == last)
    first = last = NULL;
   else first = first -> next;
   value = temp -> data;
   delete temp;
   return true;
 }
template <class NodeType>
bool List<NodeType>::removeFromEnd (NodeType &value)
 { if ( isEmpty () ) return false;
   ListNode <NodeType> *temp = last;
   if (first == last)
    first = last = NULL;
   else { ListNode <NodeType> *current = first;
            while (current -> next != last)
             current = current -> next;
            last = current;
            last -> next = NULL;
          }
   value = temp -> data;
   delete temp;
   return true;
 }
template <class NodeType>
void List<NodeType>::print () const
 { if ( isEmpty () )
    { cout << "  !\n";
      return;
    }
   cout << ": ";
   ListNode <NodeType> *current = first;
   while (current != NULL)
    { cout << current -> data << ' ';
      current = current -> next;
    }
   cout << endl;
 }
#endif
