/* Zaglaven fail kum programa ot lekciite po SDP
na doc. Buchvarov napisana ot men, Ivan Dimitrov Georgiev
(veche zavurshil) student po informatika, e-mailut mi e
ivandg@yahoo.com
*/
#ifndef TREE_H
#define TREE_H
#include <cassert>
#include "treenode.h"
template < class NodeType >
class Tree {
 public:
     Tree ();
     void insertNode (const NodeType &);
     void preOrderTraversal () const;
     void inOrderTraversal () const;
     void postOrderTraversal () const;
 private:
     TreeNode < NodeType > *rootPtr;
     void insertNodeHelper (TreeNode <NodeType >*&, const NodeType &);
     void preOrderHelper (TreeNode <NodeType >*) const;
     void inOrderHelper (TreeNode <NodeType >*) const;
     void postOrderHelper (TreeNode <NodeType >*) const;
} ;

template < class NodeType >
Tree < NodeType > :: Tree ()
 { rootPtr = 0; }
template < class NodeType >
void Tree < NodeType > :: insertNode ( const NodeType &value )
 { insertNodeHelper (rootPtr, value); }
template < class NodeType >
void Tree < NodeType > :: insertNodeHelper 
   	( TreeNode < NodeType > *& ptr, const NodeType &value )
 { if (ptr == NULL) 
    {  ptr = new TreeNode <NodeType> (value);
      assert (ptr != NULL);
    }
  else if (value < ptr -> data)
     insertNodeHelper ( ptr -> leftPtr, value );
  else if (value > ptr -> data)
     insertNodeHelper ( ptr -> rightPtr, value );
  else cout << value << "  !" << endl;
 }
template < class NodeType >
void Tree < NodeType > :: preOrderTraversal () const
 { preOrderHelper (rootPtr); }
template < class NodeType >
void Tree < NodeType > :: preOrderHelper (TreeNode <NodeType> *ptr) const
 { if (ptr != 0) 
    {  cout << ptr -> data << ' ';
       preOrderHelper (ptr -> leftPtr);
       preOrderHelper (ptr -> rightPtr);
    }
 }
template < class NodeType >
void Tree < NodeType > :: inOrderTraversal () const
 { inOrderHelper (rootPtr); }
template < class NodeType >
void Tree < NodeType > :: inOrderHelper (TreeNode <NodeType> *ptr) const
 { if (ptr != 0) 
    {  inOrderHelper (ptr -> leftPtr);
       cout << ptr -> data << ' ';
       inOrderHelper (ptr -> rightPtr);
    }
 }
template < class NodeType >
void Tree < NodeType > :: postOrderTraversal () const
 { postOrderHelper (rootPtr); }
template < class NodeType >
void Tree < NodeType > :: postOrderHelper (TreeNode <NodeType> *ptr) const
 { if (ptr != 0) 
    {  postOrderHelper (ptr -> leftPtr);
       postOrderHelper (ptr -> rightPtr);
       cout << ptr -> data << ' ';
    }
 }
#endif
