/* Chast ot Visual C++ 5.0 proekt za realizirane na
algoritmite po grafika, napisana ot men Ivan Dimitrov Georgiev
(veche zavurshil) student po informatika, e-mailut mi e
ivandg@yahoo.com
*/
struct Point {
	double x, y;
};

class CMainFrame : public CFrameWnd
{
public:
	void FourSymmetric(int xc, int yc, int x, int y, int val[]);
	void EightSymmetric (int xc, int yc, int x, int y, int val[]);
	void DrawPoint(int x, int y, int val[]);

	void SimpleLine(int x1, int y1, int x2, int y2, int val[]);
	void SimpleCutLine(int x1, int y1, int x2, int y2, int z, int val[]);
	void BresenhamLine (int x1, int y1, int x2, int y2, int c[3]);
	void LineSys(int x1, int y1, int x2, int y2, int c[3]);
	void CutLineSys(int x1, int y1, int x2, int y2, int c[3]);
	void PortionLine(int x1, int y1, int x2, int y2, int val[]);

	void DrawCircle(int xc, int yc, int R, int val[]);
	void DrawCircleOct(int xc, int yc, int R, int val[]);
	void DrawCircleSys(int xc, int yc, int R, int val[]);
	void DrawBresenhamCircle(int xc, int yc, int R, int val[]);
	void DrawMichenerCircle(int xc, int yc, int R, int val[]);
	void DrawCircleSecondDiff(int xc, int yc, int R, int val[]);
	void DrawEllipse(int xc, int yc, int a, int b, int val[]);
	void DrawEllipseGeneral(double a, double b, double c, double d, double e, double f, int val[]);

	void DrawFilledCircleBr(int xc, int yc, int R, int val[]);
    void DrawFilledPolygon(int n, Point p[], int val[]);

    int CohenSutherland(double x1, double y1, double x2, double y2,
					    double xmin, double ymin, double xmax, double ymax,
						double *X1, double *Y1, double *X2, double *Y2);
    int LiangBarskey   (double x1, double y1, double x2, double y2,
					    double xmin, double ymin, double xmax, double ymax,
						double *X1, double *Y1, double *X2, double *Y2);
	int LBCalc(double R, double Q, double &tin, double &tout);
	int SutherlandHodgeman(Point Pin[], int Nin, Point Pout[], int *Nout,
						   double xmin, double ymin, double xmax, double ymax);
	int SHCbl(Point Pin[], int Nin, Point Pout[], int *Nout, Point Lb, Point Le);
	Point Intersect(Point P1, Point P2, Point Q1, Point Q2);
	int CyrusBeck(double x1, double y1, double x2, double y2,
			  double *X1, double *Y1, double *X2, double *Y2,
			  Point P[], int n);
    int NicolLeeNicol  (double x1, double y1, double x2, double y2,
					    double xmin, double ymin, double xmax, double ymax,
						double *X1, double *Y1, double *X2, double *Y2);

	int OverHauser();
	CMainFrame();
	~CMainFrame();
	void ExecutePart1();
	void ExecutePart2();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);

	DECLARE_MESSAGE_MAP()
};