/* Chast ot Visual C++ 5.0 proekt za realizirane na
algoritmite po grafika, napisana ot men Ivan Dimitrov Georgiev
(veche zavurshil) student po informatika, e-mailut mi e
ivandg@yahoo.com
*/
#include "list.h"
#include <math.h>
#define EPS 0.00000001
LinkedListArc::LinkedListArc()
{
	List = 0;
}
void LinkedListArc::AddElement(double x1, double y1, double x2, double y2)
{
	ListNode *newel = new ListNode;
	newel -> ymax = (y1 < y2) ? y2 : y1;
	if (fabs(newel -> ymax - y1) < EPS) newel -> xmin = x2;
	else newel -> xmin = x1;
	newel -> incx = (x2 - x1)/(y2 - y1);
	newel -> next = List;
	List = newel;
}
LinkedListArc::~LinkedListArc()
{ ListNode *help;
  while (List)
  {
	  help = List;
	  List = List -> next;
	  delete help;
  }
}
void LinkedListArc::ModifyElements()
{ ListNode *iter = List;
  while (iter)
  {
	  iter -> xmin += iter->incx;
	  iter = iter -> next;
  }
}
ListNode *LinkedListArc::Merge(ListNode *a, ListNode *b)
{
	ListNode *ans, *beg;
	if (!a) return b;
	if (!b) return a;
	if (a -> xmin < b -> xmin) { beg = ans = a; a = a->next;}
	else { beg = ans = b; b = b->next;}
	if (a && b)
	  while (1)
	  {
		if (a -> xmin < b -> xmin)
		{  ans -> next = a; a = a -> next;
		}
		else
		{  ans -> next = b; b = b -> next;
		}
		ans = ans -> next;
		if (!a || !b) break;
	  }
	if (!a) ans -> next = b; else ans -> next = a;
	return beg;
}
void LinkedListArc::Sort()
{
	List = Sort1(List);
}
ListNode* LinkedListArc::Sort1(ListNode *L)
{
	if (!L || !(L->next))
		return L;
    ListNode *a = L, *b = L, *c;
	while (1)
	{
      b = b->next->next;
      if (b && b -> next)
		  a = a->next;
	  else {
		  c = a -> next;
		  a -> next = 0;
		  a = c;
		  break;
	  }
	}
    L = Sort1(L);
	a = Sort1(a);
	return Merge(L,a);
}

void LinkedListArc::DeleteElements(double y)
{
  ListNode *iter, *help;
  if (!List) return;
  while (List && (fabs(List -> ymax - y) < EPS || List -> ymax < y))
  {
	  help = List;
	  List = List -> next;
	  delete help;
  }
  iter = List;
  while (iter && iter -> next)
  {
      if (fabs(iter -> next -> ymax - y) < EPS || List -> ymax < y) 
		{ help = iter -> next;
		  iter -> next = iter -> next -> next;
		  delete help;
	    }
	  else iter = iter -> next;     
  }
}

void LinkedListArc::AddList(LinkedListArc &L)
{
	if (!List) { List = L.List; return; }
	ListNode *iter = List;
    while (iter -> next) iter = iter -> next;
    iter -> next = L.List;
}


void LinkedListArc::StartIter()
{ iterator = List; }

void LinkedListArc::GetX1X2(int &x1, int &x2)
{ x1 = (int)(iterator ->xmin+0.5); x2 = (int)(iterator->next->xmin+0.5); }

int LinkedListArc::MoveIter()
{ iterator = iterator -> next -> next;
  if (!iterator || !iterator->next) return 0;
  else return 1;
}
