#include <stdio.h>
#include <math.h>
unsigned n, m, y;
FILE *fout; //provide access to output file from every function
/*********************************/
//careful multiplication not to exceed 4*10^9
unsigned multmodulom (unsigned x, unsigned y)
  { return (3 * ((x * (y / 3)) % m) + x * (y % 3)) % m; } 
/*********************************/
unsigned power(unsigned x, unsigned k) //fast exponentiation modulo m
 { if (k == 0) return 1;
   else if (k % 2 == 1) return multmodulom (x, power(x, k-1));
   else { unsigned p = power (x, k/2);
          return multmodulom (p, p);
        }
 }
/*********************************/
void computeanswer ()
 { unsigned x, nosolution = 1;
   for (x = 0; x < m; x++)
      if (power (x, n) == y)
        { if (nosolution) //no space before first number in output
               { nosolution = 0; fprintf (fout, "%d", x); }
          else fprintf (fout, " %d", x);
        }
   if (nosolution) fprintf (fout, "-1");
   fprintf (fout, "\n");
   fclose (fout);
 }
/*********************************/
void input()
 { FILE *fin = fopen ("power.inp", "r");
   fout = fopen ("power.out", "w");
   fscanf (fin, "%u%u%u", &n, &m, &y);
   fclose (fin);
 }
/*********************************/
void main ()
 { input ();
   computeanswer ();
 }

