#include <stdio.h>
#define N 105
struct list {
 int v;
 list *next;
};
list *graph[N]; //list of successors
int anscount; //number of vertices in answer
int answer[N]; //teams in answer
int n; //number of vertices
char visited[N]; //visited[i] <-> vertex i is visited
/*********************************/
//adding element to a linked list
void add (list *&l, int v)
 { list *newl = new list;
   newl -> v = v;
   newl -> next = l;
   l = newl;
 }
/*********************************/
void bfs (int v) //bfs with starting vertex v
 { if ( graph[v] == NULL ) //no solution only when there are isolated vertices
    { anscount = 0;
      return;
    }
   struct node {
     int ver;
     int level;
   } queue[N]; //queue for breadth first search
   int head = 1; //head of queue
   int tail = 1; //tail of queue
   queue[1].ver = v; //initialize queue
   queue[1].level = 0;
   visited[v] = 1;
   while (head <= tail)
    { //the neighbours of the current vertex
      list *neigh = graph[queue[head].ver];
      if (queue[head].level % 2 == 0) //answer is vertices with even level
        { anscount++;
          answer[anscount] = queue[head].ver;
        }
      while ( neigh != NULL ) // walk the unvisited neighbours and add them to the queue
        { if (!visited[neigh->v])
            { visited[neigh->v] = 1;
              queue[++tail].ver = neigh->v;
              queue[tail].level = queue[head].level + 1;
            }
          neigh = neigh -> next;
        }
      head++;
    }
  }
/*********************************/
void computeanswer ()
 { int v;
   for (v = 1; v <= n; v++) //walk all connected components of the graph
    { if (!visited[v])
         bfs (v);
      if (anscount == 0) return; //there is an isolated vertex -> no solution
    }
 }
/*********************************/
void output ()
 { int i;
   FILE *fout = fopen ("teams.out", "w");
   fprintf (fout, "%d\n", anscount);
   if (anscount > 0)
     { for (i = 1; i < anscount; i++)
         fprintf (fout, "%d ", answer[i]);
       fprintf (fout, "%d\n", answer[anscount]);
     }
   fclose (fout);
 }
/*********************************/
void input ()
 { int i, j;
   FILE *fin = fopen ("teams.inp", "r");
   fscanf (fin, "%d", &n);
   for (i = 1; i <= n; i++)
     while (1)
       { fscanf (fin, "%d", &j);
         if (j == 0) break;
           add (graph[i], j);
       }
   fclose (fin);
 }
/*********************************/
void main ()
 { input ();
   computeanswer ();
   output ();
 }

